# TODO:
# - think about some trigger to upgrade from 6.5-1 and older
#   (I suggest just to forget about those broken version,
#   unfortunately they have already landed in Ac)
# - apache1 config
# - security CVE-2006-1945, CVE-2006-2237: http://security.gentoo.org/glsa/glsa-200606-06.xml
Summary:	Advanced Web Statistics is a free powerful server log file analyzer
Summary(pl.UTF-8):	Zaawansowany program do analizowania logów serwera
Name:		awstats
Version:	7.9
Release:	1
License:	GPL v3+
Group:		Applications/Networking
Source0:	http://awstats.sourceforge.net/files/%{name}-%{version}.tar.gz
# Source0-md5:	c283e0170700461596f9c9e121ea2896
Source1:	%{name}.crontab
Source2:	%{name}-httpd.conf
Source3:	%{name}.conf
Source4:	%{name}-lighttpd.conf
Patch0:		%{name}_conf.patch
Patch1:		%{name}-created_dir_mode.patch
Patch2:		%{name}-PLD.patch
URL:		https://awstats.sourceforge.io/
BuildRequires:	rpm-perlprov
BuildRequires:	rpmbuild(macros) >= 1.264
Requires(postun):	sed >= 4.0
Requires:	perl-Geo-IP
Requires:	perl-Storable
Requires:	perl-Time-HiRes
Requires:	webapps
Suggests:	crondaemon
Conflicts:	apache-base < 2.4.0-1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# java code is run on clients browser
%define		_noautoreqfiles	%{_datadir}/awstats/wwwroot/classes/.*

%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}

%description
Advanced Web Statistics is a powerful and featureful tool that
generates advanced web server graphic statistics. This server log
analyzer works from command line or as a CGI and shows you all
information your log contains, in graphical web pages. It can analyze
a lot of web/wap/proxy servers like Apache, IIS, Weblogic, Webstar,
Squid, ... but also mail or FTP servers.

This program can measure visits, unique vistors, authenticated users,
pages, domains/countries, OS busiest times, robot visits, type of
files, search engines/keywords used, visits duration, HTTP errors and
more... Statistics can be updated from a browser or your scheduler.
The program also supports virtual servers, plugins and a lot of
features.

%description -l pl.UTF-8
awstats (Advanced Web Statistics - zaawansowane statystyki WWW) to
potężne i bogate w możliwości narzędzie generujące zaawansowane
graficzne statystyki serwera WWW. Ten analizator logów serwera działa
z linii poleceń lub jako CGI i pokazuje wszystkie informacje zawarte w
logu w postaci graficznych stron WWW. Może analizować logi wielu
serwerów WWW/WAP/proxy, takich jak Apache, IIS, Weblogic, Webstar,
Squid... ale także serwerów pocztowych lub FTP.

Ten program może mierzyć odwiedziny, odwiedzających, uwierzytelnionych
użytkowników, strony, domeny/kraje, najbardziej zajęte godziny,
odwiedziny robotów, rodzaje plików, używane wyszukiwarki i słowa
kluczowe, czasy trwania odwiedzin, błędy HTTP... a nawet więcej.
Statystyki mogą być uaktualniane z przeglądarki lub schedulera.
Program obsługuje także serwery wirtualne, wtyczki i wiele innych
rzeczy.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
find . '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/cron.d,%{_sysconfdir},%{_bindir}} \
	$RPM_BUILD_ROOT{%{_datadir}/awstats,/var/lib/awstats}

install -p tools/awstats_* $RPM_BUILD_ROOT%{_bindir}
install -p tools/{logresolvemerge,maillogconvert,urlaliasbuilder}.pl $RPM_BUILD_ROOT%{_bindir}
rm -rf wwwroot/classes/src
cp -r wwwroot $RPM_BUILD_ROOT%{_datadir}/awstats
mv $RPM_BUILD_ROOT%{_datadir}/awstats/wwwroot/cgi-bin/awstats.model.conf $RPM_BUILD_ROOT%{_sysconfdir}
mv $RPM_BUILD_ROOT%{_datadir}/awstats/wwwroot/cgi-bin/{lang,lib,plugins} $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -p %{SOURCE1} $RPM_BUILD_ROOT/etc/cron.d/awstats
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.conf
cp -p %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf
ln -s %{_datadir}/awstats/wwwroot/cgi-bin/awstats.pl $RPM_BUILD_ROOT%{_bindir}

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache-base
%webapp_unregister httpd %{_webapp}

%triggerin -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%triggerpostun -- %{name} < 6.5-2.1
# rescue app configs.
for i in awstats.conf awstats.model.conf; do
	if [ -f /etc/%{name}/$i.rpmsave ]; then
		mv -f %{_sysconfdir}/$i{,.rpmnew}
		mv -f /etc/%{name}/$i.rpmsave %{_sysconfdir}/$i
	fi
done

# nuke very-old config location (this mostly for Ra)
if [ -f /etc/httpd/httpd.conf ]; then
	sed -i -e "/^Include.*%{name}.conf/d" /etc/httpd/httpd.conf
fi

# migrate from httpd (apache2) config dir
if [ -f /etc/httpd/%{name}.conf.rpmsave ]; then
	cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
	mv -f /etc/httpd/%{name}.conf.rpmsave %{_sysconfdir}/httpd.conf
fi

# migrate from apache-config macros
if [ -f /etc/%{name}/apache.conf.rpmsave ]; then
	if [ -d /etc/httpd/webapps.d ]; then
		cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/httpd.conf
	fi
	rm -f /etc/%{name}/apache.conf.rpmsave
fi

rm -f /etc/httpd/httpd.conf/99_%{name}.conf
/usr/sbin/webapp register httpd %{_webapp}
%service -q httpd reload

%files
%defattr(644,root,root,755)
%doc README.md docs/* tools/webmin tools/xslt
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(644,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/awstats*.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/cron.d/awstats

%attr(755,root,root) %{_bindir}/*.pl
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/lang
%{_datadir}/%{name}/lib
%{_datadir}/%{name}/plugins
%dir %{_datadir}/%{name}/wwwroot
%dir %{_datadir}/%{name}/wwwroot/cgi-bin
%attr(755,root,root) %{_datadir}/%{name}/wwwroot/cgi-bin/awdownloadcsv.pl
%attr(755,root,root) %{_datadir}/%{name}/wwwroot/cgi-bin/awredir.pl
%attr(755,root,root) %{_datadir}/%{name}/wwwroot/cgi-bin/awstats.pl
%{_datadir}/%{name}/wwwroot/classes
%{_datadir}/%{name}/wwwroot/css
%{_datadir}/%{name}/wwwroot/icon
%{_datadir}/%{name}/wwwroot/js
%attr(775,root,stats) /var/lib/%{name}
%changelog
* Fri Mar 15 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/awstats.git;a=log;h=master

* Sun Jan 07 2024 Marcin Krol <hawk@tld-linux.org> 9361983
- updated to 7.9

* Wed Nov 24 2021 Marcin Krol <hawk@tld-linux.org> 02ef1ae
- drop java dependency, code is run by browsers, drop java source too

* Thu Nov 18 2021 Marcin Krol <hawk@tld-linux.org> e4fd165
- updated to 7.8

* Sat Jan 25 2020 Jan Rękorajski <baggins@pld-linux.org> e8adfd9
- drop obsolete and outdated manual inclusion of rpm macros

* Wed Mar 13 2019 Jan Rękorajski <baggins@pld-linux.org> 2aa9a7c
- release 2 (by relup.sh)

* Tue Mar 05 2019 Marcin Krol <hawk@tld-linux.org> 4297478
- revert, commited by mistake

* Tue Mar 05 2019 Marcin Krol <hawk@tld-linux.org> c4acedb
- updated to 7.7

* Sun May 08 2016 Patryk Szczygłowski <patryk@patryk.net> 6bdfa70
- up to 7.5
- rel 1
- license change: GPL v3+

* Wed May 14 2014 Elan Ruusamäe <glen@delfi.ee> 7b692be
- suggest/require crondaemon
- release 3 (by relup.sh)

* Wed May 15 2013 Jan Rękorajski <baggins@pld-linux.org> 4a9b8f2
- C proper package
- rel 2

* Wed May 15 2013 Jan Rękorajski <baggins@pld-linux.org> 9638226
- migrate to apache 2.4

* Sat Dec 15 2012 Patryk Szczygłowski <patryk@patryk.net> 2a807c7
- version 7.1

* Thu Jan 13 2011 Elan Ruusamäe <glen@pld-linux.org> aba656d
- up to 7.0

* Wed May 19 2010 pawelz <pawelz@pld-linux.org> 9a3a03c
- up to 6.95

* Tue Mar 24 2009 luzik <luzik@pld-linux.org> b011c50
- updated to 6.9

* Tue Mar 24 2009 luzik <luzik@pld-linux.org> 0c12f33
- updated to 6.9, STBR

* Fri Dec 28 2007 zbyniu <zbyniu@pld-linux.org> 993bf03
- up to 6.8

* Sun Oct 07 2007 Tomasz Pala <gotar@pld-linux.org> 529130c
- upgraded to 6.7

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> b09e5a9
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> e418261
- converted to UTF-8

